---
title: HTMLTableRowElement
slug: Web/API/HTMLTableRowElement
tags:
  - API
  - HTML DOM
  - Interface
  - Reference
---
<div>{{ APIRef("HTML DOM") }}</div>

<p>The <strong><code>HTMLTableRowElement</code></strong> interface provides special properties and methods (beyond the {{domxref("HTMLElement")}} interface it also has available to it by inheritance) for manipulating the layout and presentation of rows in an HTML table.</p>

<p>{{InheritanceDiagram(600, 120)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLTableRowElement.cells")}} {{readonlyInline}}</dt>
 <dd>Returns a live {{domxref("HTMLCollection")}} containing the cells in the row. The <code>HTMLCollection</code> is live and is automatically updated when cells are added or removed.</dd>
 <dt>{{domxref("HTMLTableRowElement.rowIndex")}} {{readonlyInline}}</dt>
 <dd>Returns a <code>long</code> value which gives the logical position of the row within the entire table. If the row is not part of a table, returns <code>-1</code>.</dd>
 <dt>{{domxref("HTMLTableRowElement.sectionRowIndex")}} {{readonlyInline}}</dt>
 <dd>Returns a <code>long</code> value which gives the logical position of the row within the table section it belongs to. If the row is not part of a section, returns <code>-1</code>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{domxref("HTMLElement")}}</em>.</p>

<dl>
 <dt>{{domxref("HTMLTableRowElement.deleteCell()")}}</dt>
 <dd>Removes the cell at the given position in the row. If the given position is greater (or equal as it starts at zero) than the amount of cells in the row, or is smaller than <code>0</code>, it raises a {{domxref("DOMException")}} with the <code>IndexSizeError</code> value.</dd>
 <dt>{{domxref("HTMLTableRowElement.insertCell()")}}</dt>
 <dd>Inserts a new cell just before the given position in the row. If the given position is not given or is <code>-1</code>, it appends the cell to the row. If the given position is greater (or equal as it starts at zero) than the amount of cells in the row, or is smaller than <code>-1</code>, it raises a {{domxref("DOMException")}} with the <code>IndexSizeError</code> value. Returns a reference to a {{domxref("HTMLTableCellElement")}}.</dd>
</dl>

<h2 id="Deprecated_properties">Deprecated properties</h2>

<div class="notecard warning">
<p><strong>Warning:</strong> These properties have been <a class="new" rel="nofollow" title="Page has not yet been created.">deprecated</a> and should no longer be used. They are documented primarily to help understand older code bases.</p>
</div>

<details>
<dl>
 <dt>{{domxref("HTMLTableRowElement.align")}} {{obsolete_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} containing an enumerated value reflecting the {{htmlattrxref("align", "tr")}} attribute. It indicates the alignment of the element's contents with respect to the surrounding context. The possible values are <code>"left"</code>, <code>"right"</code>, and <code>"center"</code>.</dd>
 <dt>{{domxref("HTMLTableRowElement.bgColor")}} {{obsolete_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} containing the background color of the cells. It reflects the obsolete {{htmlattrxref("bgColor", "tr")}} attribute.</dd>
 <dt>{{domxref("HTMLTableRowElement.ch")}} {{obsolete_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} containing one single character. This character is the one to align all the cell of a column on. It reflects the {{htmlattrxref("char", "tr")}} and default to the decimal points associated with the language, e.g. <code>'.'</code> for English, or <code>','</code> for French. This property was optional and was not very well supported.</dd>
 <dt>{{domxref("HTMLTableRowElement.chOff")}} {{obsolete_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} containing a integer indicating how many characters must be left at the right (for left-to-right scripts; or at the left for right-to-left scripts) of the character defined by <code>HTMLTableRowElement.ch</code>. This property was optional and was not very well supported.</dd>
 <dt>{{domxref("HTMLTableRowElement.vAlign")}} {{obsolete_inline}}</dt>
 <dd>Is a {{domxref("DOMString")}} representing an enumerated value indicating how the content of the cell must be vertically aligned. It reflects the {{htmlattrxref("valign", "tr")}} attribute and can have one of the following values: <code>"top"</code>, <code>"middle"</code>, <code>"bottom"</code>, or <code>"baseline"</code>.</dd>
</dl>
</details>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#htmltablerowelement", "HTMLTableRowElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "tabular-data.html#the-tr-element", "HTMLTableRowElement")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>The parameter of <code>insertCell</code> is now optional and default to <code>-1</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 HTML', 'html.html#ID-6986576', 'HTMLTableRowElement')}}</td>
   <td>{{Spec2('DOM2 HTML')}}</td>
   <td>The <code>cells</code>, <code>rowIndex</code>, and <code>selectionRowIndex</code> properties are now read-only.<br>
    The methods <code>insertCell</code> and <code>deleteCell</code> can raise exceptions.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-html.html#ID-6986576', 'HTMLTableRowElement')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLTableRowElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The HTML element implementing this interface: {{HTMLElement("tr")}}.</li>
</ul>
